package bank3tier.db; //DbReicheKundenQuery

//2005-04-22  Knabe  Erstellt

import java.util.List;

import javax.persistence.EntityManager;

import bank3tier.db.Pool.ArgumentCountExc;
import bank3tier.db.Pool.ArgumentTypeExc;

public final class DbReicheKundenQuery extends HibernateQuery {

/**Liefert alle Zeilen der angesprochenen Tabelle kz, mit der Spalte inhaber=true und kz.konto.saldo ab i_args[0].
 * @throws ArgumentCountExc i_args nicht 1 Argument hat
 * @throws ArgumentTypeExc  i_args[0] nicht vom Typ Integer
 */
    @Override
    <T> List<T> execute(final _HibernateJpaPool io_hibernatePool, final Class<T> i_resultClass, final Object[] i_args)
    throws ArgumentCountExc, ArgumentTypeExc
    {
        final int providedCount = i_args.length;
        final int neededCount = 1;
        if(providedCount!=neededCount){
            throw new ArgumentCountExc(getClass(), providedCount, neededCount);
        }
        final int argumentIndex = 0;
        final Object arg0 = i_args[argumentIndex];
        if(!(arg0 instanceof Integer)){
            throw new ArgumentTypeExc(getClass(), argumentIndex, arg0.getClass(), Integer.class);
        }
        final Integer saldoAbCent = (Integer)arg0;
        final EntityManager session = io_hibernatePool.getEntityManager();
		final javax.persistence.Query jpaQuery = session.createQuery("SELECT kz FROM " + i_resultClass.getName() + " AS kz "
                + "WHERE kz.inhaber=true AND kz.konto.saldo >= :saldoAbCent"
        );
        jpaQuery.setParameter("saldoAbCent", saldoAbCent);
        final List<T> results = jpaQuery.getResultList();
        return results;
	}


}
