/*
<B>Bank 3-Tier</B>,                      Prof. Knabe, 2011-11-08
<P>
Ein Beispiel, wie ein Softwaresystem für eine Bank gemäß der strengen
3-Schichten-Architektur aufgebaut ist.
<P>
Es besteht aus den Schichten:
<PRE>
   ui     User Interface
==============================
   lg     application LoGic
==============================
   db     DataBase access
</PRE>
<P>
Jede Schicht wird durch ein Paket realisiert.
Die Lg-Schicht und die Db-Schicht exportieren ihre Dienste als API.
<P>
Statt der noch leeren Ui-Schicht wird hier die Testtreiberschicht _lgTest
benutzt.
<P>
Die Db-Schicht setzt auf
JPA/Hibernate auf, das auf eine In-memory HSQLDB-Datenbank zugreift.
Die Db-Schicht enthält darüberhinaus folgende weitere Features: <UL>
  <LI>zwecks austauschbarer Persistenz alle operativen Zugriffe auf die Persistenz
    kanalisiert über das Interface Pool.
  <LI>eine eindeutige Kennung jeden Objekts durch eine Object IDentification
    (OID) vom Typ Integer. Dafür muss jede persistente Klasse
    der Lg-Schicht die abstrakte Klasse DbObject beerben.
</UL>

<P>Versionsgeschichte<UL>
  <li>2011-11-08 Umstellung auf JUnit 4.5 von JUnit 3. Umstellung Quellcode-Encoding auf UTF-8.
  <LI>2005-04-22 Testtreiber bank3tier.lg.TestLgKontoMock mit Mock-Implementierung von Pool für Test von LgKonto.ueberweisen()
  <LI>2005-04-07 Austauschbare Persistenz über Interface Pool, Verwendung von HSQLDB statt Access.
  <LI>2003-04-02 Aufbau einer TestSuite. Startklasse: bank3tier.TestAll
  <LI>2002-04-11 Lg-Operationen erfassen() und ändern() parameterlos,
    deshalb Attributwerte mittels get/set-Operationen verwalten.
    Alle Operationen der Db-Schicht mit Namenspräfix 'db'.
  <LI>2001-05-28 Verbesserte Transaktionsunterstützung durch Operation
        DbObject.retrieve(). Getter für OID umbenannt nach getOid().
        Applikationsspezifische Teile der DB-Schicht isoliert in
        Klasse DbBankApplication.
  <LI>2001-05-17 Verbesserte Diagnosehilfen (Warnungen) in JORA bei Problemen
    in der Abbildung von Java-Typen in die Datenbanktypen.
  <LI>2001-05-10 Berücksichtigung von Assoziationen
</UL>
*/
package bank3tier;
