/*
 * UiKundeList.java
 *
 * Created on 29. Juni 2001, 12:32
 */

package bank3tier.ui;
import java.util.List;

import  bank3tier.ui.UiObjectList;
import  bank3tier.lg.LgSitzung;
import  bank3tier.lg.LgKunde;
import  javax.swing.table.AbstractTableModel;
/**
 *
 * @version 2011-11-17
 */
public class UiKundeList extends UiObjectList {

    /** Creates new UiKundeList */
    public UiKundeList(final java.awt.Window io_owner){
        super(io_owner);
        _inhaltTable.setModel(new TableModel());
        _dialog.setTitle("Kunden");
        _dialog.setSize(300, 200);
        _dialog.show();
    }
    
    private class TableModel extends AbstractTableModel {
        public int getColumnCount() { return 3; }
        public String getColumnName(final int i_col){
            switch(i_col){
                case 0: return "OID";
                case 1: return "Name";
                case 2: return "Geburt";
                default: return null;
            }
        }
        
        public int getRowCount() { return _kunden.size();}
        
        public Object getValueAt(final int i_row, final int i_col) {
            final LgKunde kunde = _kunden.get(i_row); //TODO: puffern
            switch(i_col){
                case 0: return kunde.getOid();
                case 1: return kunde.getName();
                case 2: return kunde.getGeburt();
                default: return null;
            }
        }
        
    }//TableModel
    

    public void actionPerformed(final java.awt.event.ActionEvent i_event){
        final Object source = i_event.getSource();
        //System.err.println("Action: " + i_event);
        try{
            final int selectionIndex = _selection.getMinSelectionIndex();
            if(selectionIndex<0){return;}
            final LgKunde kunde = _kunden.get(selectionIndex);
            if(source==_aendernButton){
                new UiKunde(_dialog, kunde);
            }else if(source==_loeschenButton){
                kunde.loeschen();
                _closeDialog();
            }
        }catch(Exception ex){_report(ex);}
    }

    private final List<LgKunde> _kunden = UiMain.getLgApplication().alleKundenSuchen();
    

}//UiKundeList